# Copyright (C) 2009-2010 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

from zope.interface import implements

from repoze.who.interfaces import IAuthenticator, IMetadataProvider
from repoze.who.utils import resolveDotted
from luci import sasl2auth

class Sasl2AuthPlugin(object):
    implements(IAuthenticator,IMetadataProvider)

    def __init__(self,
                 server_fqdn=None,
                 user_realm=None,
                 iplocalport=None,
                 ipremoteport=None):
        self.server_fqdn = server_fqdn
        self.user_realm = user_realm
        self.iplocalport = iplocalport
        self.ipremoteport = ipremoteport

    # IAuthenticatorPlugin
    def authenticate(self, environ, identity):
        if not ('login' in identity and 'password' in identity):
            return None

        if sasl2auth.checkauth(
            identity['login'], identity['password'], self.server_fqdn,
            self.user_realm, self.iplocalport, self.ipremoteport
        ):
            return identity['login']

        return None

    def add_metadata(self, environ, identity):
        username = identity.get('repoze.who.userid')
        groups = ['managers']
        permissions = ['manage']
        identity['user'] = username
        identity['groups'] = groups
        identity['permissions'] = permissions
        if 'repoze.what.credentials' not in environ:
            environ['repoze.what.credentials'] = {}
        environ['repoze.what.credentials']['groups'] = groups
        environ['repoze.what.credentials']['permissions'] = permissions
        # Adding the userid:
        userid = identity['repoze.who.userid']
        environ['repoze.what.credentials']['repoze.what.userid'] = userid


from repoze.what.plugins.pylonshq import booleanize_predicates
booleanize_predicates()
